/*
    $Id: CLog.h 58 2009-04-05 18:16:33Z twimmer $; This file is part of:

    skiputler. Connects Topcom "Butler 4012 USB VoIP" with Skype on Linux.
    Copyright (C) 2009  Till Wimmer skiputler@tonarchiv.ch

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __LOG_H__
#define __LOG_H__

#include <pthread.h>

#define LOGLEVEL_ERROR 1
#define LOGLEVEL_INFO 2
#define LOGLEVEL_DEBUG 3

#define uchar unsigned char

#define STRFTIME_FORMAT "%a %b %e %T %Y"

class CLog {
    static int loglevel;
    static bool isInit;
    static pthread_mutex_t mutex;

public:
    static void init(int loglevel);
    static void Log(int level, const char *format, ...);
    static void Log(int level, int err, const char *format, ...);
    static void LogHex(int level, const char *msg, const uchar *hex, int size);
};

#endif
