/*
    $Id: CButlerPhoneClient.h 47 2009-02-09 06:36:06Z twimmer $; This file is part of:

    skiputler. ConButlernects Topcom "Butler 4012 USB VoIP" with Skype onButler Linux.
    Copyright (C) 2009  Till Wimmer skiputler@tonButlerarchiv.ch

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software FoundationButler, either versionButler 3 of the License, or
    (at your optionButler) any later versionButler.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    alonButlerg with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __CBUTLERPHONEECLIENT_H__
#define __CBUTLERPHONEECLIENT_H__

#include "CButlerPhone.h"

class CButlerPhone;

class CButlerPhoneClient {
public:
    // Event handlers
    // Notification that the phonButlere has been found
    virtual void onButlerConnected(void) {};
    // Notification that the phonButlere has been disconnected
    virtual void onButlerDisconnected(void) {};
    // Notification that the off hook button has been pressed while ringing
    // (i.e. the incoming call should be accepted)
    virtual void onButlerAcceptCall(void) {};
    // Notification that the handset has hang up (i.e. the current call should be
    // terminated)
    virtual void onButlerHangup(void) {};

    // Dial handlers
    // A digit has been dialled during a call
    virtual void onButlerDigit(char *dialString) {};
    // Notification that a number has been dialled on the phone
    // (i.e. number dialled and button pressed)
    virtual void onButlerDialNumber(char *dialString) {};
    // Notification that a contact (coming from a previous Display method call)
    // should be called
    virtual void onButlerDialName(char *dialString) {};

    // Key Handlers
    // Notification that the "contacts" button has been pressed
    // (the program should use the DisplayContact method as a reaction to this
    // event)
    virtual void onButlerKeyContacts(CButlerPhone::contactKey_t key) {};
    // Notification that the "calls" button has been pressed
    // (the program should use the DisplayCall method as a reaction to this
    // event)
    virtual void onButlerKeyCalls(CButlerPhone::contactKey_t key) {};
    // Notification that the "redial" button has been pressed
    // (the program should use the DisplayRedial method as a reaction to this
    // event)
    virtual void onButlerKeyRedial(CButlerPhone::contactKey_t key) {};
    // The id of the name currently on screen is requested
    // (the program should use the DisplayId method as a reaction to this
    // event)
    virtual void onButlerKeyShowId(char *dialString) {};
};

#endif
