/*
    $Id: test.cc 60 2009-04-05 18:32:06Z twimmer $; This file is part of:

    skiputler. Connects Topcom "Butler 4012 USB VoIP" with Skype on Linux.
    Copyright (C) 2009  Till Wimmer skiputler@tonarchiv.ch

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <signal.h>
#include <unistd.h>
#include <stdio.h>

#include "CLog.h"
#include "CButlerPhone.h"
#include "CButlerPhoneClient.h"

class CButlerPhoneTest : public CButlerPhoneClient {
    void onConnected(void) {puts("onConnected");};
};

int isTerm=0;

void onTerm(int sig) {
    isTerm=1;
}

int main() {
    signal(SIGTERM,onTerm);
    signal(SIGINT,onTerm);
    signal(SIGHUP,onTerm);
    signal(SIGQUIT,onTerm);

    CLog::init(LOGLEVEL_DEBUG);
    
    CButlerPhoneTest *test = new CButlerPhoneTest();

    CButlerPhone *butlerphone = new CButlerPhone(test);
    butlerphone->start();

    while (!isTerm)
        sleep(1);
    puts("Got SIGTERM.");

    delete butlerphone;
    delete test; 

    return 0;
}
