/*
    $Id: main.cc 61 2009-04-05 18:45:26Z twimmer $; This file is part of:

    skiputler. Connects Topcom "Butler 4012 USB VoIP" with Skype on Linux.
    Copyright (C) 2009  Till Wimmer skiputler@tonarchiv.ch

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <signal.h>
#include <stdio.h>
#include <string.h>

#include "CLog.h"
#include "CSkiputler.h"

int isTerm=0;

void onTerm(int sig) {
    isTerm=1;
}

int main(int argc, char *argv[]) {
    signal(SIGTERM,onTerm);
    signal(SIGINT,onTerm);
    signal(SIGHUP,onTerm);
    signal(SIGQUIT,onTerm);


    int loglevel = LOGLEVEL_ERROR;
    if (argc == 3) {
        int level;
        if ( (0 == strcmp("--loglevel", argv[1])) && (level=atoi(argv[2])) ) {
            loglevel = level;
        }
    }

    CLog::init(loglevel);

    CSkiputler *skiputler = new CSkiputler();
    skiputler->start();

    while (!isTerm)
        sleep(1);
    puts("Got SIGTERM.");

    skiputler->terminate();
    sleep(5);
    delete skiputler; 

    return 0;
}
