/*
    $Id: skypeapi-dbusobj.cc 61 2009-04-05 18:45:26Z twimmer $; This file is part of:

    skiputler. Connects Topcom "Butler 4012 USB VoIP" with Skype on Linux.
    Copyright (C) 2009  Till Wimmer skiputler@tonarchiv.ch

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "CSkypeAPI.h"
#include "skypeapi-dbusobj.h"
#include "Notify-method.h"


G_DEFINE_TYPE(SkypeAPIDBusObj, skypeapi_dbusobj, G_TYPE_OBJECT)


/*
 * Object initializer
 */
void skypeapi_dbusobj_init (SkypeAPIDBusObj *obj) {
    g_assert(obj != NULL);
}

/*
 * Class initializer
 */
void skypeapi_dbusobj_class_init (SkypeAPIDBusObjClass *klass) {
    g_assert(klass != NULL);

    /*Bind this GType into the Glib/D-Bus wrappers*/
    dbus_g_object_type_install_info (SKYPEAPI_TYPE_DBUSOBJ, &dbus_glib_skypeapi_dbusobj_object_info);
}

/*
 * Function that gets executed on "notify".
 */
gboolean skypeapi_dbusobj_notify(SkypeAPIDBusObj *obj, const char *message, GError **error) {
    g_assert(obj != NULL);
 
    if (obj->api == NULL)
        return TRUE;

    obj->api->notify(message);

    return TRUE;
}

void skypeapi_dbusobj_set_api(SkypeAPIDBusObj *obj, CSkypeAPI *api) {
    obj->api = api;
}
