/*
    $Id: skypeapi-dbusobj.h 47 2009-02-09 06:36:06Z twimmer $; This file is part of:

    skiputler. Makes Topcom "Butler 4012 USB VoIP" work with Skype on Linux.
    Copyright (C) 2009  Till Wimmer skiputler@tonarchiv.ch

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SKYPEAPI_DBUSOBJ_H__
#define __SKYPEAPI_DBUSOBJ_H__

#include <glib.h>
#include <dbus/dbus-glib.h>

class CSkypeAPI;

#define DBUS_SERVICE_SKYPE      "com.Skype.API"
#define DBUS_PATH_SKYPE_CLIENT  "/com/Skype/Client"
#define DBUS_INTERFACE_SKYPE    "com.Skype.API"

G_BEGIN_DECLS

/* Macro for the above. It is common to define macros using the
   naming convention (seen below) for all GType implementations,
   and that's why we're going to do that here as well. */
#define SKYPEAPI_TYPE_DBUSOBJ              (skypeapi_dbusobj_get_type ())
#define SKYPEAPI_DBUSOBJ(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), SKYPEAPI_TYPE_DBUSOBJ, SkypeAPIDBusObj))
#define SKYPEAPI_DBUSOBJ_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), SKYPEAPI_TYPE_DBUSOBJ, SkypeAPIDBusObjClass))
#define SKYPEAPI_IS_DBUSOBJ(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), SKYPEAPI_TYPE_DBUSOBJ))
#define SKYPEAPI_IS_DBUSOBJ_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), SKYPEAPI_TYPE_DBUSOBJ))
#define SKYPEAPI_DBUSOBJ_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), SKYPEAPI_TYPE_DBUSOBJ, SkypeAPIDBusObjClass))

typedef struct {
    GObject parent;
    CSkypeAPI *api;
} SkypeAPIDBusObj;

typedef struct {
    GObjectClass parent;
} SkypeAPIDBusObjClass;

GType skypeapi_dbusobj_get_type (void);
G_END_DECLS

gboolean skypeapi_dbusobj_notify (SkypeAPIDBusObj *obj, const char *message, GError **error);
void skypeapi_dbusobj_set_api(SkypeAPIDBusObj *obj, CSkypeAPI *api);

#endif
