/*
    $Id: test.cc 60 2009-04-05 18:32:06Z twimmer $; This file is part of:

    skiputler. Makes Topcom "Butler 4012 USB VoIP" work with Skype on Linux.
    Copyright (C) 2009  Till Wimmer skiputler@tonarchiv.ch

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <signal.h>
#include <unistd.h>
#include <stdio.h>

#include "CLog.h"
#include "CSkypeAPI.h"
#include "CSkypeAPIClient.h"

class CSkypeAPIClientTest : public CSkypeAPIClient {
    void onSkypeCall(CSkypeAPI::callStat_t status, char *dialString) {
        printf("onSkypeCall status = %u, dialString = \"%s\"\n", status, dialString);
    }
};

int isTerm=0;

void onTerm(int sig) {
    isTerm=1;
}

int main() {
    signal(SIGTERM,onTerm);
    signal(SIGINT,onTerm);
    signal(SIGHUP,onTerm);
    signal(SIGQUIT,onTerm);

    CLog::init(LOGLEVEL_DEBUG);

    CSkypeAPIClientTest *test = new CSkypeAPIClientTest();

    CSkypeAPI *skypeapi = new CSkypeAPI(test);
    skypeapi->start();

    while (!isTerm)
        sleep(1);
    puts("Got SIGTERM.");

    delete skypeapi; 

    return 0;
}
